<template>
  <form class="d-select" autocomplete="off">
    <label v-if="isLabelVisible" :class="[inError ? 'in-error' : '']" v-html="getTitle" />
    <vs-select
      v-model="value"
      :class="['w-full', classes]"
      :style="styles"
      :disabled="disabled"
      :autocomplete="autocomplete"
      name="d-select"
      :danger="inError"
      :placeholder="placeholder"
      :multiple="multiselect"
      @input="updateInput"
    >
      <vs-select-item
        v-for="(item, index) in list"
        :key="index"
        :text="getTextValue(item, index)"
        :value="!!valueParam ? item[valueParam] : item"
        :class="item[itemClassCondition] ? itemConditionalClasses.onTrue : itemConditionalClasses.onFalse"
      />
    </vs-select>
  </form>
</template>

<script>
export default {
  props: {
    disabled: {
      required: false,
      type: Boolean,
      default: false
    },
    multiselect: {
      required: false,
      type: Boolean,
      default: false
    },
    autocomplete: {
      required: false,
      type: Boolean,
      default: false
    },
    label: {
      required: false,
      type: String,
      default: "&nbsp"
    },
    placeholder: {
      required: false,
      type: String,
      default: ""
    },
    value: {
      required: false,
      type: [Object, Array, String, Number],
      default: ""
    },
    list: {
      // text or number
      required: false,
      type: Array,
      default: () => []
    },
    textParams: {
      // will generate item text with all these params values with spaces between them
      required: false,
      type: Array,
      default: () => []
    },
    textParamFuncIndex: {
      // user function with index incoming parameter to show text value
      required: false,
      type: Function,
      default: null
    },
    textParamFuncItem: {
      // user function with item incoming parameter to show text value
      required: false,
      type: Function,
      default: null
    },
    // textParamCondition: {
    // 	required: false,
    //   type: Boolean,
    //   default: false
    // },
    // textParamFalseCondtion: {
    // 	required: false,
    //   type: String,
    //   default: ''
    // },
    textParamsUpper: {
      // converts text value to uppercaser
      required: false,
      type: Boolean,
      default: false
    },
    valueParam: {
      required: false,
      type: String,
      default: ""
    },
    inError: {
      // use for manual marking it in error
      required: false,
      type: Boolean,
      default: false
    },
    required: {
      required: false,
      type: Boolean,
      default: false
    },
    styles: {
      required: false,
      type: String,
      default: ""
    },
    classes: {
      required: false,
      type: String,
      default: ""
    },
    showLabel: {
      // for cases when we don't need to have label tag at all
      required: false,
      type: Boolean,
      default: true
    },
    showLabelOnMobile: {
      // for cases when we don't need to have label tag at all on mobile
      required: false,
      type: Boolean,
      default: true
    },
    itemClassCondition: {
      // applies [onTrue] class when positive, else [onFalse]
      required: false,
      type: Boolean,
      default: false
    },
    itemConditionalClasses: {
      required: false,
      type: Object,
      default: () => {
        return {
          onTrue: "",
          onFalse: ""
        };
      }
    }
  },
  computed: {
    getTitle() {
      let append = "";
      if (this.required) {
        append = " *";
      }
      return `${this.label}${append}`;
    },

    isLabelVisible() {
      if (this.isMobile) {
        return this.showLabelOnMobile;
      } else {
        return this.showLabel;
      }
    },

    isMobile() {
      return screen.width < 576;
    }
  },
  methods: {
    updateInput() {
      this.$emit("input", this.value);
    },
    getTextValue(item, index) {
      if (
        this.textParams.length > 0 ||
        this.textParamFuncItem ||
        this.textParamFuncIndex
      ) {
        if (this.textParamFuncItem) {
          return this.textParamFuncItem(item);
        } else if (this.textParamFuncIndex) {
          return this.textParamFuncIndex(index);
        } else {
          return this.getTextByParams(item);
        }
      } else {
        return item;
      }
    },
    getTextByParams(item) {
      let result = "";
      this.textParams.forEach(param => {
        if (this.textParamsUpper) {
          if (item[param]) {
            // it must not be null
            result += item[param].toUpperCase() + " ";
          } else {
            result += "";
          }
        } else {
          result += item[param] + " ";
        }
      });
      return result;
    }
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/_variables.scss";

.d-select {
  // .vs-input-primary .vs-input--input:focus {
  // 	border-color: $d-input-focus-color !important;
  // }
  label {
    font-size: $d-input-label-size;
    padding-left: $d-input-label-padding;
  }

  .in-error {
    color: red !important;
  }
}
</style>
